# This file is part of SSHare.
#
# SSHare is free software: you can redistribute it and/or modify it under the terms of
# the GNU General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later version.
#
# SSHare is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# SSHare. If not, see <https://www.gnu.org/licenses/>.

import argparse
import locale
import subprocess

from sshare.plugin.config import Argument
from sshare.plugin.source import Raw

plugin_type = "source"

activate = { "command" }
config = {
    "suffix": "txt",
}
args = {
    "command": Argument(
        nargs=argparse.REMAINDER,
        help="Upload the contents of the wrapped command",
    )
}

def init():
    config.command = config.command[1:]

def get_source():
    output = b""
    with subprocess.Popen(
        config.command,
        stdout=subprocess.PIPE,
        stderr=subprocess.STDOUT,
        bufsize=0,
    ) as process:
        for line in process.stdout:
            print(line.decode(locale.getpreferredencoding()), end="")
            output += line

    return Raw(config.suffix, output)
